<?php
if (!defined('SMF'))
	die('Hacking attempt...');

function Handler()
{
	global $user_info, $topic, $txt, $context;

	if (!isset($_SESSION['old_url']))
		redirectexit('topic='.$topic.'.0');

	if ($user_info['is_guest']&&false)
		redirectexit('topic='.$topic.'.0');

	// Must have someone to add/delete and it must be you or admin
	if (!isset($_POST['ID_SIGNUP'])||(!allowedTo('moderate_forum')&&$_POST['ID_SIGNUP']!=$context['user']['id']))
		redirectexit('topic='.$topic.'.0');

	checkSession();

	if(empty($_POST['eventid']))
		redirectexit('topic='.$topic.'.0');

	if (empty($_POST['Button']))
		$_POST['Button'] = "";

	switch ($_POST['Button'])
	{
		// Clicked register, show T&C page
		case $txt['register_mod_registerButtonValue']:
			confirmTC();
			break;
		// I agree, so lets register
		case $txt['register_mod_iAgree']:
			Register();
			break;
		// clicked unregister, lets do it!
		case $txt['register_mod_unregisterButton']:
			Unregister();
			break;
		// clicked confirm, i guess we confirm!
		case $txt['register_mod_confirmButton']:
			ConfirmEvent();
			break;
		// you get the point...
		case $txt['register_mod_unconfirmButton']:
			UnconfirmEvent();
			break;
		default:
			break;
	}
}

function confirmTC()
{
	global $smcFunc, $user_info, $topic, $txt, $context, $termsAndCond;
	$request = $smcFunc['db_query']('', '
			SELECT termsAndCond
			FROM {db_prefix}calendar
			WHERE ID_EVENT={int:eventid}',
			array(
				'eventid' => (int)$_POST['eventid']
			)
	);
	$row = $smcFunc['db_fetch_assoc']($request);
	$termsAndCond = $row['termsAndCond'];
	$smcFunc['db_free_result']($request);


	// pftq: Skip template if blank
	if($termsAndCond) loadTemplate('TermsAndConditions');
	else Register();
}

function Register()
{
	global $smcFunc, $context, $user_info, $topic, $txt;

	// No empty signups
	if (empty($_POST['Registrant']))
		redirectexit('topic='.$topic.'.0');

	// Check if already registered
	// pftq: Added registrant name
	$request = $smcFunc['db_query']('', '
		SELECT ID_MEMBER
		FROM {db_prefix}calendar_reg
		WHERE ID_MEMBER={int:userid} AND ID_EVENT={int:eventid}
		AND registrant={string:registrant}
		LIMIT 1',
		array(
			'userid' => (int) $context['user']['id'],
			'eventid' => (int)$_POST['eventid'],
			'registrant' => $smcFunc['htmlspecialchars'](strip_tags($_POST['Registrant']), ENT_QUOTES)
		)
	);

	if ($smcFunc['db_num_rows']($request) != 0)
	{
		$smcFunc['db_free_result']($request);
		fatal_error($txt['register_mod_alreadyRegistered'], false);
	}
	$smcFunc['db_free_result']($request);

	// still here, not registered, lets do it
	// pftq: added registrant name, signup comment

	if(!isset($_POST['Comment'])) $_POST['Comment']="";

	$request = $smcFunc['db_query']('', '
		INSERT INTO {db_prefix}calendar_reg (ID_MEMBER, ID_EVENT, dateRegistered, registrant, comment)
		VALUES({int:userid}, {int:eventid}, {int:date_registered},{string:registrant}, {string:comment})',
		array(
			'userid' => (int) $context['user']['id'],
			'eventid' => (int)$_POST['eventid'],
			'date_registered' => time(),
			'registrant' => $smcFunc['htmlspecialchars'](strip_tags($_POST['Registrant']), ENT_QUOTES),
			'comment' => $smcFunc['htmlspecialchars'](strip_tags($_POST['Comment']), ENT_QUOTES)
		)
	);

	redirectexit('topic='.$topic.'.0');
}

function Unregister()
{
	global $smcFunc, $user_info, $topic, $txt;

	// pftq: Added registrant name
	$request = $smcFunc['db_query']('', '
		DELETE FROM {db_prefix}calendar_reg
		WHERE ID_MEMBER={int:id_signup} AND ID_EVENT={int:eventid}
		AND registrant={string:registrant}',
		array(
			'id_signup' => (int)$_POST['ID_SIGNUP'],
			'eventid' => (int)$_POST['eventid'],
			'registrant' => $smcFunc['htmlspecialchars'](strip_tags($_POST['Registrant']), ENT_QUOTES)
		)
	);

	redirectexit('topic='.$topic.'.0');
}

function ConfirmEvent()
{
	global $smcFunc, $user_info, $topic, $txt;

	// Check if already registered
	// pftq: Added registrant name
	$request = $smcFunc['db_query']('', '
		SELECT ID_MEMBER
		FROM {db_prefix}calendar_reg
		WHERE ID_MEMBER={int:id_signup} AND ID_EVENT={int:eventid}
		AND registrant={string:registrant}
		LIMIT 1',
		array(
			'id_signup' => (int)$_POST['ID_SIGNUP'],
			'eventid' => (int)$_POST['eventid'],
			'registrant' => $smcFunc['htmlspecialchars'](strip_tags($_POST['Registrant']), ENT_QUOTES)
		)
	);

	if ($smcFunc['db_num_rows']($request) == 0)
	{
		$smcFunc['db_free_result']($request);
		fatal_error($txt['register_mod_haventRegistered'], false);
	}
	$smcFunc['db_free_result']($request);

	// still here, lets confirm
	$request = $smcFunc['db_query']('', '
		UPDATE {db_prefix}calendar_reg
		SET dateConfirmed={int:date_confirmed}
		WHERE ID_MEMBER={int:id_signup} AND ID_EVENT={int:eventid}
		AND registrant={string:registrant}',
		array(
			'date_confirmed' => time(),
			'id_signup' => (int)$_POST['ID_SIGNUP'],
			'eventid' => (int)$_POST['eventid'],
			'registrant' => $smcFunc['htmlspecialchars'](strip_tags($_POST['Registrant']), ENT_QUOTES)
		)
	);

	redirectexit('topic='.$topic.'.0');
}

function UnconfirmEvent()
{
	global $smcFunc, $user_info, $topic, $txt;

	// Check if already registered
	// pftq: Added registrant name
	$request = $smcFunc['db_query']('', '
		SELECT ID_MEMBER
		FROM {db_prefix}calendar_reg
		WHERE ID_MEMBER={int:id_signup} AND ID_EVENT={int:eventid}
		AND registrant={string:registrant}
		LIMIT 1',
		array(
			'id_signup' => (int)$_POST['ID_SIGNUP'],
			'eventid' => (int)$_POST['eventid'],
			'registrant' => $smcFunc['htmlspecialchars'](strip_tags($_POST['Registrant']), ENT_QUOTES)
		)
	);

	if ($smcFunc['db_num_rows']($request) == 0)
	{
		$smcFunc['db_free_result']($request);
		fatal_error($txt['register_mod_haventRegistered'], false);
	}
	$smcFunc['db_free_result']($request);

	// still here, lets confirm
	$request = $smcFunc['db_query']('', '
		UPDATE {db_prefix}calendar_reg
		SET dateConfirmed=0
		WHERE ID_MEMBER={int:id_signup} AND ID_EVENT={int:eventid}
		AND registrant={string:registrant}',
		array(
			'id_signup' => (int)$_POST['ID_SIGNUP'],
			'eventid' => (int)$_POST['eventid'],
			'registrant' => $smcFunc['htmlspecialchars'](strip_tags($_POST['Registrant']), ENT_QUOTES)
		)
	);

	redirectexit('topic='.$topic.'.0');
}
?>
