<?php
if (file_exists(dirname(__FILE__) . '/SSI.php') && !defined('SMF'))
	require_once(dirname(__FILE__) . '/SSI.php');
elseif (!defined('SMF'))
	die('<b>Error:</b> Cannot install - please verify you put this in the same place as SMF\'s index.php.');

if($smcFunc['db_query']('', "CREATE TABLE IF NOT EXISTS {db_prefix}calendar_reg
	(
	  `ID_ENTRY` smallint(5) unsigned NOT NULL AUTO_INCREMENT,
	  `dateRegistered` int(10) unsigned NOT NULL DEFAULT '0',
	  `ID_EVENT` smallint(5) unsigned NOT NULL,
	  `ID_MEMBER` mediumint(8) unsigned NOT NULL DEFAULT '0',
	  `dateConfirmed` int(10) unsigned NOT NULL DEFAULT '0',
	  `registrant` varchar(100) not null,
	  PRIMARY KEY (`ID_ENTRY`),
	  KEY `dateRegistered` (`dateRegistered`),
	  KEY `event` (`ID_EVENT`,`ID_MEMBER`)
	)") === false)
	echo '<b>Error:</b> Failed to insert new table.';

// pftq: Add registrant name if installing over older version
if($smcFunc['db_num_rows']($smcFunc['db_query']('', "show columns from {db_prefix}calendar_reg like 'registrant'"))==0)
	if($smcFunc['db_query']('', "ALTER TABLE {db_prefix}calendar_reg ADD (`registrant` varchar(100) not null)") === false)
		echo '<b>Error:</b> Failed to insert new column(s) to calendar_reg table';
		
// pftq: Add comment field for signups if installing over older version
if($smcFunc['db_num_rows']($smcFunc['db_query']('', "show columns from {db_prefix}calendar_reg like 'comment'"))==0)
	if($smcFunc['db_query']('', "ALTER TABLE {db_prefix}calendar_reg ADD (`comment` varchar(100) not null)") === false)
		echo '<b>Error:</b> Failed to insert new column(s) to calendar_reg table';
	

/*$result = db_query("SELECT `maxAttendants` FROM {$db_prefix}calendar", __FILE__, __LINE__);
if(!$result)
{
	if(db_query("ALTER TABLE {$db_prefix}calendar ADD IF NOT EXISTS `maxAttendants` SMALLINT( 5 ) UNSIGNED NOT NULL DEFAULT '50'", __FILE__, __LINE__) === false)
		echo '<b>Error:</b> Failed to insert new column to calendar table';
}*/
	
$result = $smcFunc['db_query']('', "SHOW COLUMNS FROM {db_prefix}calendar");

$MaxAttendantsExists = false;
$DaysConfirmExists = false;
$DaysSortExists = false;
$DaysClosedExists = false;
$termsandcondExists = false;

// pftq: Multiple signups and guests
$multipleSignups = false;
$allowGuests = false;
// pftq: Allow comments to go with signups?
$allowComments = false;
while ($row = $smcFunc['db_fetch_assoc']($result))
{
	if($row['Field'] == "maxAttendants")
	{
		$MaxAttendantsExists = true;
		continue;
	}
	if($row['Field'] == "daysConfirm")
	{
		$DaysConfirmExists = true;
		continue;
	}
	if($row['Field'] == "daysSort")
	{
		$DaysSortExists = true;
		continue;
	}
	if($row['Field'] == "daysClosed")
	{
		$DaysClosedExists = true;
		continue;
	}
	if($row['Field'] == "termsAndCond")
	{
		$termsandcondExists = true;
		continue;
	}
	
	// pftq: Multiple signups and guests
	if($row['Field'] == "multipleSignups")
	{
		$multipleSignups = true;
		continue;
	}
	if($row['Field'] == "allowGuests")
	{
		$allowGuests = true;
		continue;
	}
	
	// pftq: Comment Option
	if($row['Field'] == "allowComments")
	{
		$allowComments = true;
		continue;
	}
}

$smcFunc['db_free_result']($result);

if(!$MaxAttendantsExists || !$DaysConfirmExists || !$DaysSortExists || !$DaysClosedExists || !$termsandcondExists || !$multipleSignups || !$allowGuests || !$allowComments)
{
	$sql = "";
	if(!$MaxAttendantsExists)
		$sql .= "`maxAttendants` SMALLINT( 5 ) UNSIGNED NOT NULL DEFAULT '50', ";
	if(!$DaysConfirmExists)
		$sql .= "`daysConfirm` SMALLINT( 5 ) UNSIGNED NOT NULL DEFAULT '7', ";
	if(!$DaysSortExists)
		$sql .= "`daysSort` SMALLINT( 5 ) UNSIGNED NOT NULL DEFAULT '4', ";
	if(!$DaysClosedExists)
		$sql .= "`daysClosed` SMALLINT( 5 ) UNSIGNED NOT NULL DEFAULT '0', ";
	if(!$termsandcondExists)
		$sql .= "`termsAndCond` TEXT NOT NULL, ";
		
	// pftq: Multiple signups and guests
	if(!$multipleSignups)
		$sql .= "`multipleSignups` SMALLINT(1) UNSIGNED NOT NULL DEFAULT '0', ";
	if(!$allowGuests)
		$sql .= "`allowGuests` SMALLINT(1) UNSIGNED NOT NULL DEFAULT '0', ";
	// pftq: Multiple signups and guests
	if(!$allowComments)
		$sql .= "`allowComments` SMALLINT(1) UNSIGNED NOT NULL DEFAULT '0', ";
	
	// trim last comma and white space
	$sql = substr($sql, 0, strlen($sql) - 2);
	
	if($smcFunc['db_query']('', "ALTER TABLE {db_prefix}calendar ADD ($sql)") === false)
		echo '<b>Error:</b> Failed to insert new column(s) to calendar table';
}
?>
